import { defineComponent as i, watch as n, openBlock as f, createElementBlock as v, createElementVNode as _, unref as b } from "vue";
import { cloneDeep as r, isEqual as w } from "lodash";
import { useChart as E } from "../../core/useChart.mjs";
import { parseOtherData as O } from "../../utils/parseOtherData.mjs";
const g = { class: "zerov-widget" }, k = ["id"], D = i({ name: "zv-chart-other-candlestick-shanghai" }), V = /* @__PURE__ */ i({
  ...D,
  props: {
    basicOption: {},
    sources: {},
    useEvents: {},
    uuid: {}
  },
  emits: [
    "chart-click",
    "chart-dblclick",
    "chart-mousedown",
    "chart-mouseover",
    "chart-mouseout",
    "chart-contextmenu"
  ],
  setup(u, { expose: d, emit: h }) {
    const e = u, l = h, {
      id: p,
      setOption: a,
      chart: m,
      renderChart: c,
      renderData: o
    } = E({
      basicOption: r(e.basicOption),
      useEvents: r(e.useEvents),
      customRenderData: (t) => {
        t = r(t), window.SHJDatasourceV2({
          tId: e.uuid,
          sources: e.sources,
          callback: ({ data: s }) => {
            try {
              window.SHJParseEvent(e.useEvents, "dataListener", s), a(O(r(s), t));
            } catch {
              window.SHJParseEvent(e.useEvents, "dataListener", null), a(t);
            }
          }
        });
      },
      emit: l
    });
    return n(() => e.sources, () => {
      e.sources && e.sources.length > 0 && o(e.basicOption);
    }, {
      deep: !0
    }), n(() => r(e.basicOption), (t, s) => {
      w(t, s) || c(t);
    }, {
      deep: !0
    }), d({
      getEchartsInstance: () => m.value,
      refresh: () => {
        e.sources && e.sources.length > 0 && c(e.basicOption), o(e.basicOption);
      },
      refreshView: () => {
        e.sources && e.sources.length > 0 && c(e.basicOption);
      },
      refreshData: () => {
        o(e.basicOption);
      }
    }), (t, s) => (f(), v("div", g, [
      _("div", {
        id: b(p),
        class: "widget"
      }, null, 8, k)
    ]));
  }
});
export {
  V as default
};
